// Code generated by genpjrpc. DO NOT EDIT.
//  genpjrpc version: v0.1.0

package rpcclient

import (
	"context"
	"fmt"
	"helloworld/model/types"

	"github.com/google/uuid"
	"gitlab.com/pjrpc/pjrpc/v2/client"
)

// List of the client JSON-RPC methods.
const (
	JSONRPCMethodHelloMethod_Client = "hello_method"
)

// HelloServiceClient is an API client for HelloService service.
type HelloServiceClient interface {
	// HelloMethod documentation of the Hello RPC method.
	// Name of the method will convert to 'hello_method' (snake_case) JSON-RPC method.
	// You must use named Go type as request and response of the method.
	// Also you can use special magic comment to pass some settings for swagger spec.
	// See README for details: //genpjrpc:params.
	HelloMethod(ctx context.Context, in *types.HelloRequest, mods ...client.Mod) (*types.HelloResponse, error)
}

type implHelloServiceClient struct {
	cl client.Invoker
}

// NewHelloServiceClient returns new client implementation of the HelloService service.
func NewHelloServiceClient(cl client.Invoker) HelloServiceClient {
	return &implHelloServiceClient{cl: cl}
}

// HelloMethod documentation of the Hello RPC method.
// Name of the method will convert to 'hello_method' (snake_case) JSON-RPC method.
// You must use named Go type as request and response of the method.
// Also you can use special magic comment to pass some settings for swagger spec.
// See README for details: //genpjrpc:params.
func (c *implHelloServiceClient) HelloMethod(ctx context.Context, in *types.HelloRequest, mods ...client.Mod) (result *types.HelloResponse, err error) {
	gen, err := uuid.NewUUID()
	if err != nil {
		return result, fmt.Errorf("failed to create uuid generator: %w", err)
	}

	err = c.cl.Invoke(ctx, gen.String(), JSONRPCMethodHelloMethod_Client, in, result, mods...)
	if err != nil {
		return result, fmt.Errorf("failed to Invoke method %q: %w", JSONRPCMethodHelloMethod_Client, err)
	}

	return result, nil
}
